package tese.intervalos.teste;
import java.math.BigDecimal;
import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;
import tese.intervalos.operacoes.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Teste {


  private static void teste1 () {
    Intervalo f = new Intervalo(new Number("10E29"));
    Intervalo g = new Intervalo(new Number("1"));
    Intervalo h = new Intervalo(new Number("10E28"));
    f = new Adicao(f,g) ;
    f = new Subtracao(f,h);
    System.out.println("f=" + f);
    System.out.println("f.limSup=" + f.getLimiteSuperior().toScientificNotation(39));
  }

  private static void teste2 () {
    Intervalo f = new Intervalo("-874E23","-0");
    System.out.println(f + "=" + f.valorAbsoluto());
    Intervalo g = new Intervalo("+874E23","+0");
    System.out.println(g + "=" + g.valorAbsoluto());
    Intervalo h = new Intervalo(".874E23/-12","+100/-12E34");
    System.out.println(h + "=" + h.valorAbsoluto());
    Intervalo i = new Intervalo("0.E0","0");
    System.out.println(i + "=" + i.valorAbsoluto());
    //Intervalo j = new Intervalo("-0000","-000-.12100/12+E34/-123");
    //System.out.print(j.valorAbsoluto());
  }

  private static void teste3 () {
    Number n = new Number("-0,0013E3/-13");
    System.out.println(n.toScientificNotation(15));
    n = new Number("1291212");
    System.out.println(n.toScientificNotation(4));
    n = new Number("-9459845");
    System.out.println(n.toScientificNotation(9));
    n = new Number("-100000/-25");
    System.out.println(n.toScientificNotation(9));
    n = new Number("-023747E-12");
    System.out.println(n.toScientificNotation(9));
    n = new Number("-023747E-12/134E-12");
    System.out.println(n);
    System.out.println(n.toScientificNotation(0));
    System.out.println(n.toScientificNotation(1));
    System.out.println(n.toScientificNotation(2));
    System.out.println(n.toScientificNotation(3));
  }


  private static void testeAdicaoNumber(){
    Number a = new Number("-98123713E234/123123E123");
    Number b = new Number("-9123923829/12");
    System.out.println("=" + Number.adicionar(a,b).toScientificNotation(20));
  }

  private static void testeSubtracaoNumber(){
    Number a = new Number("34765783465E3");
    Number b = new Number("8123923829345435/12");
    System.out.println("=" + Number.subtrair(a,b).toScientificNotation(10));
  }

  private static void testeMultiplicaoNumber(){
    Number a = new Number("762354762534765324/-987");
    Number b = new Number("-25647864356254874/32E-2");
    System.out.println("=" + Number.multiplicar(a,b).toScientificNotation(10));
  }

  private static void testeDivisaoNumber(){
    Number a = new Number("9873892173983/234342");
    Number b = new Number("3489756345345/49538457");
    System.out.println("=" + Number.dividir(a,b,true,1).toScientificNotation(10));
    System.out.println("=" + Number.dividir(a,b,false,10));
    System.out.println("=" + Number.dividir(a,b,true,10));
  }

  private static void testeInversoMultiplicativoNumber(){
    Number a = new Number("436587436756/1234");
    System.out.println("=" + Number.inversoMultiplicativo(a));
    System.out.println("=" + Number.inversoMultiplicativo(a).toScientificNotation(10));
  }

  private static void testeAdicaoIntervalar(){
    Intervalo a = new Intervalo("822/1234","833/1234");
    Intervalo b = new Intervalo("-12E-3","1582E-2");
    //System.out.println("=" + new Adicao (a,b).toScientificNotation(10));
  }

  private static void testeSubtracaoIntervalar(){
    Intervalo a = new Intervalo("-199121212","-199121212.1");
    Intervalo b = new Intervalo("-199121211.77","-199121211.7");
    //System.out.println("=" + new Subtracao (a,b).toScientificNotation(10));
  }

  private static void testeMultiplicacaoIntervalar(){
    Intervalo a = new Intervalo("-1123.1212212","1123.32456");
    Intervalo b = new Intervalo("121.00034444","121.00000345");
    //System.out.println("=" + new Multiplicacao (a,b).toScientificNotation(15));
  }

  private static void testeInversoMultiplicativoIntervalar(){
    Intervalo a = new Intervalo("98383838","98383849");
    //System.out.println("=" + new InversoMultiplicativo(a).toScientificNotation(10));
  }

  private static void testeDivisaoIntervalar(){
  Intervalo a = new Intervalo("-2010220.2234","-2010220.9899");
  Intervalo b = new Intervalo("50021","50224.23");

    //System.out.println("=" + new Divisao(a,b).toScientificNotation(20));
  }

   private static void testeInterseccaoIntervalar(){
    Intervalo a = new Intervalo("230203","-2010220.9899");
    Intervalo b = new Intervalo("87686","-120215.23");
    //System.out.println("=" + new Interseccao(a,b).toScientificNotation(10));
  }

  private static void testeUniaoIntervalar(){
   Intervalo a = new Intervalo("-0.120120","1.12122112");
   Intervalo b = new Intervalo("0.0001212","-1.234434");
   //System.out.println("=" + new Uniao(a,b).toScientificNotation(10));
  }

  private static void testeDistanciaIntervalar(){
    Intervalo a = new Intervalo("-0.3726483838","1.293874");
    Intervalo b = new Intervalo("0.39393993933","-3.983274");
    //System.out.println("=" +  Intervalo.getDistancia(a,b).toScientificNotation(10));
  }

  private static void testeDiametro(){
    Intervalo a = new Intervalo("873264263.12341243","873264263.2948");
    //System.out.println("=" +  a.getDiametro().toScientificNotation(16));
  }

  private static void testePontoMedio(){
    Intervalo a = new Intervalo("873264263.12341243","873264263.2948");
    //System.out.println("=" +  a.getPontoMedio(10).toScientificNotation(15));
  }

  private static void testeValorabsoluto(){
    Intervalo a = new Intervalo("873264263.12341243","873264263.2948");
    //System.out.println("=" +  a.valorAbsoluto().toScientificNotation(15));
  }

  private static void testeCombinadoIntervalar(){
   Intervalo g = new Intervalo("9.9", "9.7");
   Intervalo v0 = new Intervalo("32.5", "33");
   Intervalo t = new Intervalo ("3","4");
   Intervalo s0 = new Intervalo("15","20");
   Intervalo S = new Adicao(s0,
                       new Subtracao(
                          new Multiplicacao(v0,t),
                          new Divisao(
                              new Multiplicacao(g, new Multiplicacao(t,t)),
                              new Intervalo("2","2")
                          )
                       )
                 );
   System.out.println("S =" + S.toScientificNotation(15));
 }

 private static void distanciaComValorAbsoluto(){
   Intervalo a = new Intervalo("8,732642632091062E8", "8,732642632091062E8");
   System.out.println(a);
   Intervalo b = new Intervalo("8.732642632948E8", "8.732642632948E8");
   System.out.println(b);
   Number i = Intervalo.getDistancia(a,b).modulo();
   System.out.println("|a - b| = " + i);
 }

  public static void main(String args[]) {
    int i = 21199999;
    char[] c= new char[i];
    //System.out.println(i);
    //teste1();
    //teste2();
    //teste3();
    //teste4();
    //teste5();
    //teste6();
    //teste7();
    long maxt = 0;
    long t = 0;
    long total = System.currentTimeMillis();
    for (int j=0; j< 1000; j++){
    t = System.currentTimeMillis();
    //teste3();
    //testeAdicaoNumber();
    //testeMultiplicaoNumber();
    //testeDivisaoNumber();
    //testeSubtracaoNumber();
    //testeInversoMultiplicativo();
    //testeAdicaoIntervalar();
    //testeSubtracaoIntervalar();
    //testeMultiplicacaoIntervalar();
    //testeInversoMultiplicativoIntervalar();
    //testeDivisaoIntervalar();
    //testeInterseccaoIntervalar();
    //testeUniaoIntervalar();
    //testeDistanciaIntervalar();
    //testeDiametro();
    //testePontoMedio();
    testeValorabsoluto();
    //testeCombinadoIntervalar();
    //distanciaComValorAbsoluto();
    t = System.currentTimeMillis() - t;
     if (t > maxt){
       maxt = t;
       System.out.println(maxt);
     }
    }
    total = System.currentTimeMillis() - total;
    System.out.println("total: " + total);
  }


}